︠b5cf9881-48fa-4c00-aa9c-9ebf0c764babi︠
%md
## Chapter 16 - Large Primes ##
︡0b23af18-6ac6-4255-be77-7534df8551c8︡︡{"done":true,"md":"## Chapter 16 - Large Primes ##"}
︠8e3c4e07-360c-461e-808a-b73ff205ca79i︠
%md
#### Fermat numbers ####
︡cc225bb9-a9a8-453a-acbe-5f6a359a717e︡{"md":"#### Fermat numbers ####\n"}︡
︠2e96d96d-2672-4d9a-9fc3-4ac524439598i︠
%md
We define a function to output Fermat numbers:
︡ed6b8af3-eb74-49bd-9d15-8dfaf70eded5︡{"md":"We define a function to output Fermat numbers:\n"}︡

︠c52ba2e1-3fe5-4e8c-8235-1badded0b05c︠
def fermat(n):
    return(2^(2^n)+1)
︡7b050289-c92f-4e9d-8512-f47f2ba7382a︡
︠d7cbfc09-0dc0-4794-875e-7ab7ecc02387︠
fermat(3)

︡e6515a3f-bc7b-474b-b560-cadeecf20b21︡{"stdout":"257\n"}︡
︠f46e5760-0d46-4be8-ace2-b2921dc8558c︠
︠89694ebf-b1c4-493b-8149-9732b9b03b29i︠
%md
A table of the first few Fermat numbers:
︡8afcbdcd-2b0d-4b1f-9ec7-d057a94ff52e︡{"md":"A table of the first few Fermat numbers:\n"}︡
︠a11046dd-05e8-4061-b0b2-7b1936e8d003︠
︠c64d24e4-d0d6-4f76-9d84-a4a0aa77745e︠
table([(n,fermat(n),is_prime(fermat(n))) for n in [0..5]], header_row=["n", "F_n","Prime?"], frame=True)
︡2b7b35c2-1b79-4b0b-9283-dd566913271e︡{"stdout":"+---+------------+--------+\n| n | F_n        | Prime? |\n+===+============+========+\n| 0 | 3          | True   |\n+---+------------+--------+\n| 1 | 5          | True   |\n+---+------------+--------+\n| 2 | 17         | True   |\n+---+------------+--------+\n| 3 | 257        | True   |\n+---+------------+--------+\n| 4 | 65537      | True   |\n+---+------------+--------+\n| 5 | 4294967297 | False  |\n+---+------------+--------+\n"}︡
︠46780b6c-cdc2-422f-b6e1-22e1aaa2fd2ei︠
%md
Factorization of F<sub>5</sub>:
︡330ddbc9-9754-4962-bf25-197f9766dc6a︡{"md":"Factorization of F<sub>5</sub>:\n"}︡
︠efef39be-dedf-4606-b35d-86171e11505d︠
factor(fermat(5))
︡3f001688-2856-4c3b-ae70-86435cb15b53︡{"stdout":"641 * 6700417\n"}︡
︠6c62dc71-5c29-42f8-89b4-fcacd7ad00c8i︠
%md
The procedure below will compute appropriate powers of 3 mod F<sub>3</sub> to allow us to apply Peppin's test:
︡af5de11a-6ff6-43ca-9489-4fd8f5c08990︡{"md":"The procedure below will compute appropriate powers of 3 mod F<sub>3</sub> to allow us to apply Peppin's test:\n"}︡
︠acfca96a-385e-47fa-8340-ecc3411e9ccb︠
a=3
for n in [1..(2^3)-1]:
    a=mod(a^2,fermat(3))
print(a,fermat(3))
︡26da1977-717c-4512-a868-0130ac443962︡{"stdout":"(256, 257)\n"}︡
︠7bde6e13-ee78-4173-885a-ada7c8c5fca0i︠
%md
Thus, Peppin's test implies F<sub>3</sub> is prime.  Now we try it for F<sub>7</sub>:
︡f4a58cf3-9e76-45f5-98fe-870d7e661b4f︡{"md":"Thus, Peppin's test implies F<sub>3</sub> is prime.  Now we try it for F<sub>7</sub>:\n"}︡
︠ad74adbe-e694-4553-bf51-2de5df4d0f0f︠
a=3
for n in [1..2^7-1]:
    a=mod(a^2,fermat(7))
print(a,fermat(7))
︡bba7b3c9-c2a6-4db3-a9ea-f31a77156057︡{"stdout":"(110780954395540516579111562860048860420, 340282366920938463463374607431768211457)\n"}︡
︠5f5a7e8d-8423-466f-b4ad-76a7070430a0i︠
%md
In this case, Peppin's test tell us that F<sub>7</sub> is composite.
︡f1b82073-2fe8-4fa0-a77c-5ffd0a5d6705︡{"md":"In this case, Peppin's test tell us that F<sub>7</sub> is composite.\n"}︡
︠e5e87520-47c7-49b9-85ed-6a0b6cd3d6edi︠
%md
We now define a function to implement Peppin's test:
︡476cb62a-8b6e-411e-b3be-cc89fa7e2389︡{"md":"We now define a function to implement Peppin's test:\n"}︡
︠a4c2d87a-8b47-4fd5-a2e3-c0c1a1787439︠
def peppin(n):
    m=fermat(n)
    a=3
    for k in [1..(2^n-1)]:
        a=mod(a^2,m)
    if mod(a,m)==m-1:
        return("prime")
    else:
        return("composite")
︡57a09418-eaeb-4d37-af4c-d75e83fabded︡
︠c696e448-5d67-4c21-9df4-db818cdd600e︠
peppin(4)
︡904265b4-6c75-461d-b2f0-283a3a66558a︡{"stdout":"'prime'\n"}︡
︠2a7e920a-67fb-4f93-9214-b3021c5aec5b︠
peppin(5)
︡8bd16b7e-028e-4f3c-9b97-a02f8dc56a1b︡{"stdout":"'composite'\n"}︡
︠9ab78d19-60de-41c3-b0a3-64d60e67aeb1i︠
%md
Using the function we defined, we can produce a table summarizing what goes on for the first 8 Fermat numbers.
︡c9c0ed99-9897-468c-b4db-f5104c086376︡{"md":"Using the function we defined, we can produce a table summarizing what goes on for the first 8 Fermat numbers.\n"}︡
︠23176752-e9c9-4ccc-ba8e-b1cad84d91cb︠
table([(n,peppin(n)) for n in [1..8]], header_row=["n", "Result"], frame=True)

︡b95a6222-0fdf-42b1-8c0d-d5922be55eef︡{"stdout":"+---+-----------+\n| n | Result    |\n+===+===========+\n| 1 | prime     |\n+---+-----------+\n| 2 | prime     |\n+---+-----------+\n| 3 | prime     |\n+---+-----------+\n| 4 | prime     |\n+---+-----------+\n| 5 | composite |\n+---+-----------+\n| 6 | composite |\n+---+-----------+\n| 7 | composite |\n+---+-----------+\n| 8 | composite |\n+---+-----------+\n"}︡
︠1df5f53d-791e-435f-bcc4-fe7dd17b63c8i︠
%md
The built-in **factor** command can't factor F<sub>10</sub> in a reasonable amount of time.  Try it:
︡0e7acae3-4f44-4516-94a5-1a79744316a3︡{"md":"The built-in **factor** command can't factor F<sub>10</sub> in a reasonable amount of time.  Try it:\n"}︡
︠f8e55347-f76d-455e-8d0b-68038ffdb1f6︠
factor(fermat(10))
︠1dd6302b-55a7-445b-a180-4115f9ad15ddi︠
%md
However, our Peppin's test function can tell us instantly that F<sub>10</sub> is composite:
︡9fa7f4a0-0efd-416d-9be8-79143cbe157c︡︡{"done":true,"md":"However, our Peppin's test function can tell us instantly that F<sub>10</sub> is composite:"}
︠b1b8f4d0-11e7-4331-9b24-353a0e311144︠
peppin(10)
︡ccb0f08a-ceb6-46f0-adda-b3bc763df959︡{"stdout":"'composite'\n"}︡
︠4cb9ad2b-4779-486d-9084-7ee60355e4a3i︠
%md
#### Mersenne numbers ####
︡5ee082c4-c076-468d-ba1f-5d60d34dba46︡{"md":"#### Mersenne numbers ####\n"}︡

%md
We define a function to output Mersenne numbers:
︡f3020fe8-1591-4694-87c1-2b0202823f75︡{"md":"We define a function to output Mersenne numbers:\n"}︡
︠14205558-cc92-46d7-a314-bf796efb453a︠
def mersenne(n):
    return(2^n-1)

︡47ee5a98-8ee2-4a89-a060-ebf89ac8419c︡
︠3c3c3cc7-9ba2-4a89-ad76-f3b304a5341ai︠
%md
The procedure below will find the Mersenne primes with exponent less than 258:
︡cfc89927-ddda-4f5f-8af4-d2bac3976f2d︡{"md":"The procedure below will find the Mersenne primes with exponent less than 258:\n"}︡
︠4977a2f2-d1ae-4875-b6bb-270f29be8127︠
p=2
mp=[]
while p<258:
    if is_prime(mersenne(p)):
        mp.append([p,mersenne(p)])
    p=next_prime(p)
print(table(mp))
︡9bf164ef-188a-45f6-afa5-b530353ccee0︡{"stdout":"  2     3\n  3     7\n  5     31\n  7     127\n  13    8191\n  17    131071\n  19    524287\n  31    2147483647\n  61    2305843009213693951\n  89    618970019642690137449562111\n  107   162259276829213363391578010288127\n  127   170141183460469231731687303715884105727\n"}︡
︠770b6949-d7f7-4448-8ff8-e89d00c10aec︠

︠0295196c-ef16-4908-92c8-db510954a66ci︠
%md 
Using Fermat's Little Theorem we can sometimes show a Mersenne number is composite.
︡42789e42-f680-4063-a2d0-d6bfc13a64b5︡{"md":"Using Fermat's Little Theorem we can sometimes show a Mersenne number is composite.\n"}︡
︠ef09192c-acbf-4557-aed2-ec3b2832813f︠
3.powermod(mersenne(11)-1,mersenne(11))
︡545989b0-080d-4dbd-8a1f-ae235de8c0fa︡{"stdout":"1013\n"}︡
︠5ebb3a31-c908-41e4-aae9-44b113c2f04ai︠
%md
Thus M<sub>7</sub> is composite.
︡f44a6465-05b9-465f-ba7a-64ccf537b4c0︡{"md":"Thus M<sub>7</sub> is composite."}︡
︠46ad2091-61ad-4cad-ac70-5d2f1e0bc552︠
3.powermod(mersenne(67)-1,mersenne(67))
︡cec60171-4e66-4c6a-9027-f9e3c914d8ed︡{"stdout":"95591506202441271281\n"}︡
︠556fa05e-2f4b-4735-8d91-c12cada4972bi︠
%md
Thus M<sub>67</sub> is composite.
︡4f9cb8dc-75a3-4105-8a15-27b11cd711d4︡{"md":"Thus M<sub>67</sub> is composite.\n"}︡
︠7bbe9dc7-d733-4988-b647-516514b6d93e︠
factor((2^67-1))
︡089d5b6f-ea39-43e9-8b0a-f98015cce052︡{"stdout":"193707721 * 761838257287"}︡{"stdout":"\n"}︡

︠68fdc418-5a6e-4934-8ea5-d1bdf0784fc8i︠
%md
#### Lucas-Lehmer test ####
︡4948e4d4-cb72-4caf-89f9-20ae27d1b74a︡{"md":"#### Lucas-Lehmer test ####\n"}︡
︠836a3823-46f4-4d1d-b173-f07d6be50b59︠
r=4
print(r)
for n in [1..5]:
    r=mod(r^2-2,127)
    print(r)
    
︡169cde01-5b5c-4dae-8381-ea452c4cb5b5︡{"stdout":"4\n"}︡{"stdout":"14\n67\n42\n111\n0\n"}︡
︠0dcdb84b-275e-48ba-ab75-ec30666682eei︠
%md
Thus M<sub>7</sub> is prime.
︡771ae602-75a7-4c64-9cb3-efaf7cb89e67︡{"md":"Thus M<sub>7</sub> is prime.\n"}︡
︠eaea7eec-a2b9-478c-9230-24b93b1149dfi︠
%md 
The following function implements the Lucas-Lehmer test:
︡e2e5dd9b-f810-4a0e-ae8d-042d37c7852b︡{"md":"The following function implements the Lucas-Lehmer test:\n"}︡
︠2aad7cdb-ff98-485c-a415-ce1694f448c1︠
def lltest(p):
    m=mersenne(p)
    r=4
    for k in [2..p-1]:
        r=mod(r^2-2,m)
    if r==0:
        return("prime")
    else:
        return("composite")
︡f4bb4bb2-f922-49df-884c-57155f002ee5︡
︠178b2bfa-83d3-4d33-a36e-7d939db7ddb9︠
lltest(521)
︡437cb0b8-ba73-40a0-82c4-4a8f4af054fe︡{"stdout":"'prime'\n"}︡
︠32041dfd-2313-4163-8be0-dad38525b42bi︠
%md
We now use our function to find the Mersenee primes with exponent less than 500.
︡73542237-d6dd-4a2e-978b-904e1145729a︡{"md":"We now use our function to find the Mersenee primes with exponent less than 500.\n"}︡
︠47134d40-871a-4ab2-9bca-1b4147f2428f︠
p=2
mp=[]
while p<5000:
    if lltest(p)=="prime":
        mp.append(p)
    p=next_prime(p)
print(mp)
︡11800d4c-2fe1-4244-a96b-eaf3d2f816db︡{"stdout":"[3, 5, 7, 13, 17, 19, 31, 61, 89, 107, 127, 521, 607, 1279, 2203, 2281, 3217, 4253, 4423]\n"}︡

︠6b1d1a33-392b-48ee-bd6d-247f6bcb9821i︠
%md
#### Prime Certificates ####
︡b2b8690b-bb72-4769-a1cd-d7b6e6ac1b7f︡{"md":"#### Prime Certificates ####\n"}︡
︠3ad8303f-e3fa-4e47-90a1-7e47176827fc︠
︠e88d2833-df74-4bc0-8813-7b8d6d379782i︠
%md
The command **Primes()** will produce the set of primes, and if we apply the command **unrank(n)** to it, we obtain the n-th prime.
︡7eb03394-c3f1-4b1e-bfaa-7d6c0e3cdb26︡{"md":"The command **Primes()** will produce the set of primes, and if we apply the command **unrank(n)** to it, we obtain the n-th prime.\n"}︡
︠c3bb5040-26b0-4315-8995-c93a8c22c1fe︠
Primes().unrank(10^4-1)
︡0aea0968-ca5c-4939-ba94-1354790901a0︡{"stdout":"104729\n"}︡
︠e0126805-db14-43e3-b082-1dac44ea210f︠
factor(104729-1)
︡b2e79dbf-946f-4b6a-8ceb-b2de21b736e9︡{"stdout":"2^3 * 13 * 19 * 53\n"}︡
︠64f58ce2-afd9-458c-9e63-6899b242d8e0i︠
%md We look for a witness to the primality of 104729:
︡fba110c3-fcd5-41f4-a3ab-97e5ceaec3c9︡{"md":"We look for a witness to the primality of 104729:"}︡
︠de555317-dffb-4cf7-9221-51fd68e58b27︠
[2.powermod(104728/k,104729) for k in [2,13,19,53]]
︡4d14a227-15a5-45c4-aeb3-acfbc88f7440︡{"stdout":"[1, 2522, 48162, 1]\n"}︡
︠b6f9b38f-c63f-47e3-9299-fa88c559fb4d︠
[3.powermod(104728/k,104729) for k in [2,13,19,53]]
︡cc69724f-6a17-43e4-ad34-7839eb6e8db9︡{"stdout":"[104728, 1, 785, 78661]\n"}︡
︠40342d0c-bb83-4977-92e2-453750725f7c︠
[12.powermod(104728/k,104729) for k in [2,13,19,53]]
︡8436ec4b-44e5-4f96-bdb6-7ca8526a3521︡{"stdout":"[104728, 76744, 48162, 78661]\n"}︡
︠afb3203c-76c5-43bb-8da9-d4c425d67a8c︠
12.powermod(104728,104729)
︡519da450-4bd6-41bb-88e5-abac1edc773f︡{"stdout":"1\n"}︡
︠f7b6c763-6e52-4a98-8a85-cb820c6c6f1fi︠
%md
Thus 12 is a witness to the primality of 104729.
︡25d2f83b-97ee-467e-b027-f5a0c627ee4e︡{"md":"Thus 12 is a witness to the primality of 104729.\n"}︡
︠a04f7cfe-6ac6-434f-91d4-64db886d795ci︠
%md
The following function will return the list of prime divisors of a number:
︡41b0de45-01f6-4cd5-bbc0-c67ec64ae12b︡{"md":"The following function will return the list of prime divisors of a number:\n"}︡
︠03451a25-428c-44e9-ba5e-e576512ee847︠
def prime_divisors(n):
    primelist=[]
    L=list(factor(n))
    for m in [0..len(L)-1]:
        primelist.append(L[m][0])
    return(primelist)
︡84ff65a0-ba39-4ad4-a3d4-798c0d7678d1︡
︠7c342e76-0dee-45c8-b951-9f076459b2c8︠
prime_divisors(60)
︡1954cb08-522d-4c86-9afe-290d0fa0563c︡{"stdout":"[2, 3, 5]\n"}︡
︠3b3d8468-119b-4ffb-8493-920bcd86dd24︠
prime_divisors(2^107-2)
︡35d99c6b-794a-4356-9f09-cfedbe836408︡{"stdout":"[2, 3, 107, 6361, 69431, 20394401, 28059810762433]\n"}︡
︠9d113a5b-11ba-4772-b744-d640e138d5afi︠
%md 
The following function will produce a prime certificate when a prime number is given as input. 
︡0142132c-ce0a-4e06-a7d5-45bee5cee6fd︡{"md":"The following function will produce a prime certificate when a prime number is given as input. \n"}︡
︠b003a415-f002-41b2-888f-b428a18f6678︠
def prime_certificate(n):
    pd = prime_divisors(n-1)
    exponents= [(n-1)/k for k in pd]
    a=2
    while 1 in [a.powermod(k,n) for k in exponents]:
        a=a+1
    if a.powermod(n-1,n)==1:
        return([n,a,pd])
    else:
        return("composite")
︡676fc34e-02b1-4a13-bc0f-718dae7a69fe︡
︠502e41a7-a000-41cb-96d2-f5977d254131︠
prime_certificate(12)
︡3e9d3814-0cee-4d92-a592-cf8bd255b329︡{"stdout":"'composite'\n"}︡
︠be28ba6f-4086-4172-b7df-0ec578b7b7a1︠
prime_certificate(104729)
︡1f94c3af-0d86-4556-8f63-3fb5769135c3︡{"stdout":"[104729, 12, [2, 13, 19, 53]]\n"}︡

︠afe54700-596b-4dcd-8bfd-ce7c41168e2f︠
prime_certificate(mersenne(107))
︡a511c24b-bea3-4f42-9bbe-b2ec3a009d12︡{"stdout":"[162259276829213363391578010288127, 3, [2, 3, 107, 6361, 69431, 20394401, 28059810762433]]\n"}︡
︠37209c89-e3b3-4342-aeff-1f76a7cb2e1a︠
prime_certificate(20394401)
︡692b7a96-7e92-4fc5-97cb-b734abcda923︡{"stdout":"[20394401, 3, [2, 5, 13, 37, 53]]\n"}︡
︠d8dbb7c1-eaa6-4407-a745-b11080334f20︠
prime_certificate(28059810762433)
︡f09304d8-c192-4e34-8469-ef8a4b08447d︡{"stdout":"[28059810762433, 5, [2, 3, 41, 53, 67254877]]\n"}︡
︠12954a38-e6bd-4fc9-b376-ad4f24269b34︠
prime_certificate(mersenne(521))
︡2da75590-0641-48dd-bd92-2159e445b8e8︡{"stdout":"[6864797660130609714981900799081393217269435300143305409394463459185543183397656052122559640661454554977296311391480858037121987999716643812574028291115057151, 3, [2, 3, 5, 11, 17, 31, 41, 53, 131, 157, 521, 1613, 2731, 8191, 42641, 51481, 61681, 409891, 858001, 5746001, 7623851, 34110701, 308761441, 2400573761, 65427463921, 108140989558681, 145295143558111, 173308343918874810521923841]]"}︡{"stdout":"\n"}︡
︠fa8eeae3-f508-4ca6-9abb-3391fbcfc3a9i︠
%md
#### Example 16.11 - Finding a large prime ####
︡ba159698-e5cf-4a40-bc44-139de5c8af42︡{"md":"#### Example 16.11 - Finding a large prime ####\n"}︡
︠cd9d8bd8-7a54-488b-baec-61ca2a537923︠
p=Primes().unrank(int(10^4*random()))
p
︡5168d630-70fc-4814-9c09-82cd98eceb30︡{"stdout":"47947\n"}︡
︠3c2317f2-9b8f-48c5-869c-cc9cac4f6e1f︠
k=int(10^6*random())
k
︡e63b7d67-55cf-423c-8c8e-7c8b165d6b72︡{"stdout":"646766\n"}︡
︠eadda3c5-b3a1-440b-950b-a0a15fdd810c︠
pprime=47947*646766+1
pprime
︡8fc339e4-d6b7-42ba-b561-824b90c2efb9︡{"stdout":"31010489403\n"}︡
︠7cf64099-ed8c-45f9-9650-5633264cf4c5︠
2.powermod(pprime-1,pprime)
︡0d617b1c-91c2-41a9-b55a-786b02919e53︡{"stdout":"4\n"}︡
︠ed300ad8-c244-4771-9da3-bbbccdc5d0b1︠
pprime=706020*47947+1
pprime
︡3c3d5a16-3c30-4f94-8061-17d852227d46︡{"stdout":"33851540941\n"}︡
︠942911b9-bda5-45c1-9e09-d553ebcd9de2︠
6.powermod(pprime-1,pprime)
︡827d6549-a3ca-4356-846f-3da63e49646e︡{"stdout":"1\n"}︡
︠5a82cb36-1724-425c-8343-b97026687d84︠
prime_certificate(pprime)
︡e2536ac8-aab5-4d4f-ad14-d95bf002bfcf︡{"stdout":"[33851540941, 6, [2, 3, 5, 7, 41, 47947]]\n"}︡
︠d2033685-ad3e-4dd3-a9f8-7490dcd80792︠
pprime=509248*33851540941+1
pprime
︡415d2227-dbd0-44c6-afa9-e585d1909185︡{"stdout":"17238829521122369\n"}︡
︠713d12c5-bd10-4ee3-9663-a9bc8b4a15bc︠
3.powermod(pprime-1,pprime)
︡4d34411c-891f-4cf1-a6e8-f43f59f90f6c︡{"stdout":"1\n"}︡
︠e3c1da10-6a3f-4a10-810a-2fa57d081fec︠
prime_certificate(pprime)
︡ea214a62-de84-4bdf-b5eb-9d61344c2f56︡{"stdout":"[17238829521122369, 3, [2, 73, 109, 33851540941]]\n"}︡

︠94104992-929a-41df-b194-fef263555d7ci︠
%md
#### Procedure for finding a large prime ####
︡33553a36-27b7-47f1-a899-4d037d9f43ab︡{"md":"#### Procedure for finding a large prime ####\n"}︡
︠60c1d327-e728-4b9b-bdcf-0e7a8881685ci︠
%md
We begin by modifying out prime_certificate command to make it into a prime testing procedure.  The input is a number n to be testes and prime divisor p of n-1.
︡ba221947-6b01-4579-ae57-30a518613418︡{"md":"We begin by modifying out prime_certificate command to make it into a prime testing procedure.  The input is a number n to be testes and prime divisor p of n-1.\n"}︡
︠bdb29530-7c88-4a05-963c-283a9cb34686︠
def prime_certificate_test(n,p):
    pd = prime_divisors((n-1)/p)
    pd.append(p)
    exponents= [(n-1)/k for k in pd]
    a=2
    while a.powermod(n-1,n) ==1:
        if 1 in [a.powermod(k,n) for k in exponents]:
            a=a+1
        else:
            return("prime")
    return("composite")
︡14a23ba5-64dc-4579-8518-396b4d0d7f0d︡
︠3a6cb3c0-208e-439d-91e6-fc58b0a51efd︠
prime_certificate_test(41,5)
︡2ee407d8-fe1c-40bc-8779-a61bb5129bb1︡{"stdout":"'prime'\n"}︡
︠131ae0d4-11e0-4748-958e-7a24d3fcb7c8︠
prime_certificate_test(46,5)
︡11228a2b-fbff-4305-8c12-adcc635326d6︡{"stdout":"'composite'\n"}︡
︠cc6155a6-8d8c-4574-aba8-24f3557891cdi︠
%md
We use this function to test the primality of numbers of the form kp+1 for random values of k.
︡4b679a39-ad2c-40a6-93da-e326e0410f54︡{"md":"We use this function to test the primality of numbers of the form kp+1 for random values of k.\n"}︡
︠9a1f6cf0-cbd9-4a8e-a2ec-ec3f72299a58︠
k=int(10^6*random())
pprime=k*p+1
while prime_certificate_test(pprime,p)=="composite":
    k=int(10^6*random())
    pprime=k*p+1
p=pprime
(p,k)

︡e975c735-4e2e-48af-b8ce-14dc0f9b5abf︡{"stdout":"(33851540941, 706020)\n"}︡
︠0b0eabaa-6d8d-4971-9dd8-44793e12c027︠
47947*706020+1
︡dd751198-34fc-4cd1-bd4c-fb4f5b00e732︡{"stdout":"33851540941\n"}︡
︠75b3b2ad-d9f5-4ce8-b818-e8772bd4360b︠
prime_certificate(33851540941)
︡6c358155-9fd8-481b-958b-eee0d32e4726︡{"stdout":"[33851540941, 6, [2, 3, 5, 7, 41, 47947]]\n"}︡
︠fe9e6e32-cb4d-41b5-850f-8277f224e4c9︠
k=int(10^6*random())
pprime=k*p+1
while prime_certificate_test(pprime,p)=="composite":
    k=int(10^6*random())
    pprime=k*p+1
p=pprime
(p,k)
︡33083f5a-27d7-4fe1-957d-9532f35e4851︡{"stdout":"(17238829521122369, 509248)\n"}︡
︠ebe03bf3-a1b8-4f60-b943-0b481c4196ef︠
509248 * 33851540941+1
︡f604cc14-9c4d-4b74-9be0-acc2c3f87572︡{"stdout":"17238829521122369\n"}︡
︠c50f1781-ac34-4f68-b46c-73fd8a09c4b7︠
prime_certificate(17238829521122369)
︡1fefc190-5b47-4d19-ae35-2dc816b6fd26︡{"stdout":"[17238829521122369, 3, [2, 73, 109, 33851540941]]\n"}︡
︠f3258a56-faee-4c10-bf42-a6ccb4914ff3i︠
%md
We now build a function which automates the steps above to produce a prime with more than d digits.
︡13feafe0-2d46-40e6-b72d-65d839a41605︡{"md":"We now build a function which automates the steps above to produce a prime with more than d digits.\n"}︡
︠a8522b49-97d7-4740-81bf-42531102e57e︠
def large_prime(d):
    p=Primes().unrank(int(10^4*random()))
    while p<10^d:
        pprime=int(10^6*random())*p+1
        while prime_certificate_test(pprime,p)=="composite":
            pprime=int(10^6*random())*p+1
        p=pprime
    return(p)
︡57cfb584-9945-47f1-9b2e-5858af083d43︡
︠0000e9b0-7f3e-48c7-bb0b-338d5692c90e︠
large_prime(10)
︡59db7e21-97cf-4443-9308-4e93566e0772︡{"stdout":"3124353799825117\n"}︡
︠18ff46ac-59cd-4fbf-95c8-20b52650e094︠
large_prime(100)
︡efdaa489-b235-45df-929b-38b3b1c73ad4︡{"stdout":"101146885292260685134952367990338838962219308894528819916336354941587210297210635989873113194068712643749"}︡{"stdout":"\n"}︡
︠ae3e3e05-c365-4de6-8832-792471808f61︠









